      SUBROUTINE CLUSV1A 

C     Modified version of original clustering subroutine CLUSV1
C     comments in UPPERCASE: original, lowercase: modified or added

C THIS ROUTINE DOES THE CLUSTER ANALYSIS, TAKING DATA FROM FILE
C <MATRIX.DAT>.  PARAMETERS CONTROLLING THE ANALYSIS ARE OBTAINED
C INTERACTIVELY.  THE RESULTS ARE STORED IN FILE <OUTPUT>, AND     
C ALSO IN <CLUM>, WHICH IS USED AS AN INPUT FILE FOR THE ROUTINE
C PRETRE.                        

C     All I/O file names replaced by variables!
C     We introduce a discrimination between the dimension for the
C     declaration (ndatesx) and the actual one (ndates)
C     Common block has been replaced by parameter lists in subroutine 
C     calls!
C     All text with capital letters is from the original subroutine

C
C THIS ROUTINE DOES THE CLUSTER ANALYSIS, TAKING DATA FROM FILE
C <MATRIX.DAT>.  PARAMETERS CONTROLLING THE ANALYSIS ARE OBTAINED
C INTERACTIVELY.                
C
      INCLUDE 'includepar'
      INCLUDE 'includecom'

c  initialize cluster identification and coherence index
      DO I=1,NDATESX
        ICLU(I,0)=I ! each member is its own group
        RRX(I) = 0. ! coherence at each clustering level
      ENDDO

cAF read in names according to matrix elements
      OPEN (2,FILE='elementlist',STATUS='OLD')
      DO I = 1,NDATES
         READ (2,'(A50)') CDATE(I)
      ENDDO
      CLOSE (2)  
   
cAF  in the original subroutine m = number of elements to be clustered
      M = NDATES
      LIMIT=M-1

cAF decide if you have similarity (SIM) or dissimilarity (DIS) data
cAf or comment out the print and read statement and set isim to 1 or 2
      PRINT*,'*** Choose type of your input data in file matrix.dat ***'
      PRINT*,'For similarities type 1, for dissimilarities type 2'
      READ(*,*) ISIM
c      isim=1
      IF (ISIM .EQ. 1) CRIT = 'SIM'
      IF (ISIM .EQ. 2) CRIT = 'DIS'
      IF (ISIM .NE.1 .AND. ISIM .NE. 2) THEN
         PRINT*, 'WRONG CHOICE, START AGAIN'
         STOP
      ENDIF   

cAF  save original matrix for later rearrangement
      DO I=1,NDATESX
         DO J=1,NDATESX
            XORIG(I,J)=X(I,J)
         ENDDO
      ENDDO   


C
C INITIALIZE X, NIN, AND NVAR
C
c X has been assigned in another subroutine already 
      DO 150 I=1,NDATES
      	NVAR(I)=I ! each element is its own cluster
      	NIN(I)=1  ! size of each cluster is 1
 150  CONTINUE

C
C CLUSTER ANALYSIS
C
      ITR=0
  300 ITR=ITR+1 
C
C DETERMINE GROUPS TO BE MERGED THIS ITERATION
C saved in variables k and l
C
         IF (CRIT .EQ. 'DIS') GO TO 311
         CALL SCAN (X,NIN,NVAR,K,L,M,RX,NDATESX)
         GO TO 312
 311     CALL BSCAN (X,NIN,NVAR,K,L,M,RX,NDATESX)
 312     CONTINUE

C
C UPDATE INTER-GROUP SIMILARITY/DISSIMILARITY MATRIX TAKING INTO
C ACCOUNT THE MERGER OCCURRING THIS ITERATION
cAF New version rearranges the elements at each iteration (= clustering
cAF level)

         RRX(ITR) = RX
         NCLU = 0
cAF assign the new cluster number to merged clusters
         DO ICC = 1,NDATES
            IF( ICLU(ICC,ITR-1) .EQ. L ) ICLU(ICC,ITR) = K
         ENDDO   
cAF reduce all other cluster numbers by 1
         DO ICC = 1,NDATES
            IF (ICLU (ICC,ITR-1) .GT. L) THEN
               ICLU (ICC,ITR) = ICLU (ICC,ITR-1) - 1
            ELSEIF (ICLU(ICC,ITR-1) .LT. L) THEN
               ICLU (ICC,ITR) = ICLU (ICC,ITR-1)
            ENDIF   
            NCLU = MAX (NCLU,ICLU(ICC,ITR))
         ENDDO   

cAF don't rearrange anymore if there exists only one cluster
         IF(NCLU.EQ.1) GOTO 999
cAF rearrange the data now
         PRINT*, '=ITER= ',ITR,'/ RX=',RX,' /NCLU=',NCLU,' K=',K,' L=',L
         CALL REARRANGE
cAF during rearrangement, number of clusters may change, thus assign 
cAF new number to original variable M counting the number of clusters
         M=NCLU	
         PRINT*,'NCLU=',NCLU
         IF(NCLU.EQ.1) GOTO 999
cAF jump up to next iteration (clustering level)
      IF (ITR .LT. LIMIT) GO TO 300
 999  CONTINUE
      RETURN
      END

