      SUBROUTINE REARRANGE 

      include 'includepar'
      include 'includecom'


cAF skip rearrangement for first cluster iteration
      IF (ITR .EQ. 1 .OR. NCLU .EQ. 1) GOTO 997
    
      NITER=1
c iteration loop
200   CONTINUE

cAF initialize variables
      DO JC=1,NCLU
         NCLUSIZE(JC)=0
      ENDDO   

      DO IC=1,NDATES
         JC=ICLU(IC,ITR)
         NCLUSIZE(JC)=NCLUSIZE(JC)+1
         NCLU=MAX(NCLU,ICLU(IC,ITR))
      ENDDO  
      NREA = 0
    
C-------------------------------------------
C     Find central element for each cluster
C-------------------------------------------

C     compute total distance from each date to all other 
C     dates of the same cluster

      DO JDATE = 1,NDATES
        DSUM(JDATE) = 0.
      ENDDO  
      DO JDATE = 1, NDATES
         JC = ICLU(JDATE,ITR)	
         DO IDATE = 1, NDATES
            IC = ICLU(IDATE,ITR)
            IF (IDATE .NE. JDATE .AND. IC .EQ. JC) THEN
               DSUM(JDATE) = DSUM(JDATE) + XORIG(IDATE,JDATE)
            ENDIF
         ENDDO
      ENDDO
    
C   find central element of each cluster
C   for similarities find maximum = central element of each cluster
C   for dissimilarities find minimum
      DO JC = 1, NDATESX
         IF (CRIT .eq. 'SIM') THEN
            DC(JC) = 0.
         ELSE   
            DC(JC) = 1.E20
         ENDIF   
         IDC(JC)=JC
      ENDDO  
      DAVG=0.
      DO JDATE = 1, NDATES
         JC = ICLU(JDATE,ITR)
         DAVG = DSUM(JDATE) / ( NCLUSIZE(JC)*2 - 1 )
cAF similarities: davg .gt. dc,  dissimilarities: .lt.
         IF (CRIT .eq. 'SIM' )THEN
            IF ( DAVG .GT. DC(JC) ) THEN
               DC(JC) = DAVG  ! best mean correlation within this cluster
               IDC(JC) = JDATE  ! number of central element
            ENDIF
         ELSE
            IF ( DAVG .LT. DC(JC) ) THEN
               DC(JC) = DAVG    ! minimal distance within this cluster
               IDC(JC) = JDATE  ! number of central element
            ENDIF
         ENDIF
      ENDDO
      
C    now go through all elements and find which central element
C    is closest
cAF distinguish between dis and sim
      IF (CRIT .EQ. 'SIM') THEN
         DMAX = 1.E20
         DO ID = 1,NDATES       ! loop over all elements
            DM = 0.
            JC = ICLU(ID,ITR)
            DO IC = 1, NCLU     ! loop over all clusters
               IF (IDC(IC) .EQ. ID) then !skip diagonal elements
                  JC = ICLU(ID,ITR)
                  GOTO 876
               ENDIF   
               IF (XORIG(IDC(IC),ID) .GT. DM .AND.
     &              XORIG(IDC(IC),ID) .NE. 1) THEN
                  DM = XORIG(IDC(IC),ID)
cAF  assign new cluster number 
                  JC = ICLU(IDC(IC),ITR)
               ENDIF
            ENDDO  
 876        CONTINUE
            IF ( NCLUSIZE(ICLU(ID,ITR)) .EQ. 1 .AND. 
     &	              XORIG(IDC(IC),ID) .EQ. 1. ) JC=ICLU(ID,ITR)
            IF (DM .LT. DMAX) DMAX = DM
C        Rearrange clusters         
            IF (JC .NE. ICLU(ID,ITR) .AND. ICLU(ID,ITR) .NE. 0) THEN
               IF (NCLUSIZE(ICLU(ID,ITR)) .GT. 1 ) THEN
                  PRINT*, ICLU(ID,ITR), ' -> ', JC,' --',ID,DM,
     &                 NCLUSIZE(ICLU(ID,ITR)),NITER,CDATE(ID)(1:8),' ',
     &                 CDATE(IDC(JC))(1:8), ICLU(IDC(JC),ITR)
                  ICLU(ID,ITR) = JC
                  NREA = NREA + 1
               ENDIF
            ENDIF            
         ENDDO
cAF dissimilarities
      ELSE   
         DMAX = 0.
         DO ID = 1,NDATES       ! loop over all elements
            DM = 1.E20
            DO IC = 1, NCLU     ! loop over all clusters                
               IF (XORIG(IDC(IC),ID) .LT. DM) THEN
                  DM = XORIG(IDC(IC),ID)
                  JC = ICLU(IDC(IC),ITR)
               ENDIF
            ENDDO  
            IF (DM .GT. DMAX) DMAX = DM
C        rearrange clusters         
            IF (JC .NE. ICLU(ID,ITR) .AND. ICLU(ID,ITR) .NE. 0) THEN
               PRINT*, ICLU(ID,ITR), ' -> ', JC,' --',ID,DM,
     &              NCLUSIZE(ICLU(ID,ITR)),NITER,CDATE(ID)(1:8),' ',
     &              CDATE(IDC(JC))(1:8), ICLU(IDC(JC),ITR)
               ICLU(ID,ITR) = JC
               NREA = NREA + 1
            ENDIF
         ENDDO
      ENDIF   

cAf start another iteration, if necessary
      IF (NITER .LE. 10. .AND. NREA .NE. 0) THEN
        NITER = NITER + 1
        GOTO 200
      ENDIF
997   CONTINUE


cAF   now calculate new correlation matrix for new clusters
cAF   group correlation is mean of all correlations within the cluster
cAf   like average-linkage method

      NCLU = 0
      DO ID = 1,NDATES
         NCLU = MAX(NCLU,ICLU(ID,ITR))
      ENDDO   
    
      DO JC = 1,NCLU
         NIN(JC) = 0
         DO IC = 1,NCLU
            DISTAV(IC,JC) = 0.
            IANZ(IC,JC) = 0
         ENDDO   
      ENDDO  

      DO ID = 1,NDATES
         DO JD = 1,NDATES
            IC = ICLU(ID,ITR)
            JC = ICLU(JD,ITR)
cAF distinguish between dis and sim (add 0. or 1. for diagonal)
            IF (ID .NE. JD) THEN
               DISTAV(IC,JC) = DISTAV(IC,JC) + XORIG(ID,JD)
               IANZ(IC,JC) = IANZ(IC,JC) + 1
            ENDIF
         ENDDO
         IC = ICLU(ID,ITR)
         NIN(IC) = NIN(IC)+1
      ENDDO

      DDMIN = 1.E30
      DDMAX = -1E30
      DO IC = 1,NCLU-1
         DO JC = IC,NCLU
cAF avoid division by zero and set ianz to 1 if both values are zero
            IF (CRIT .EQ. 'SIM') THEN
               IF (DISTAV(IC,JC) .EQ. 0) IANZ(IC,JC)=1
            ELSE
               IF (DISTAV(IC,JC) .EQ. 1) IANZ(IC,JC)=1
            ENDIF   
            X(IC,JC) = DISTAV(IC,JC)/IANZ(IC,JC)
            DDMIN = MIN( DDMIN, X(IC,JC) )
            DDMAX = MAX( DDMAX, X(IC,JC) )
            X(JC,IC) = X(IC,JC)
         ENDDO
      ENDDO   
      IF (CRIT .EQ. 'DIS') THEN
         PRINT*,'DDMIN=',DDMIN,' ITERATION=',ITR
      ELSE   
         PRINT*,'DDMAX=',DDMAX,' ITERATION=',ITR
      ENDIF 


cAf write out cluster results at this iteration level:
cAf file numbers > 100 are used

      DO I = 1,NDATES
        WRITE(ITR+101,'(I3,1X,A8,1X,I3)') ICLU(I,ITR), CDATE(I), I
      ENDDO   

      RETURN 
      END
